# whmcs-api-client
OpenAPI specification for the WHMCS API endpoints.  This specification uses discriminators to properly handle polymorphic request/response schemas. The 'action' field serves as the discriminator property to differentiate between different request and response types (AddClient, UpdateClient, AddOrder). 

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import whmcs_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import whmcs_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import whmcs_client
from whmcs_client.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = whmcs_client.DefaultApi(whmcs_client.ApiClient(configuration))

try:
    # WHMCS API endpoint
    api_response = api_instance.api_post()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->api_post: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://your-whmcs-instance.com/includes*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**api_post**](docs/DefaultApi.md#api_post) | **POST** /api.php | WHMCS API endpoint

## Documentation For Models

 - [AddClientRequest](docs/AddClientRequest.md)
 - [AddClientResponse](docs/AddClientResponse.md)
 - [AddOrderRequest](docs/AddOrderRequest.md)
 - [AddOrderResponse](docs/AddOrderResponse.md)
 - [ApiPhpBody](docs/ApiPhpBody.md)
 - [UpdateClientRequest](docs/UpdateClientRequest.md)
 - [UpdateClientResponse](docs/UpdateClientResponse.md)
 - [WHMCSBaseRequest](docs/WHMCSBaseRequest.md)
 - [WHMCSBaseResponse](docs/WHMCSBaseResponse.md)
 - [WHMCSErrorResponse](docs/WHMCSErrorResponse.md)
 - [WHMCSSuccessResponse](docs/WHMCSSuccessResponse.md)

## Documentation For Authorization

 All endpoints do not require authorization.


## Author


