# coding: utf-8

"""
    WHMCS API

    OpenAPI specification for the WHMCS API endpoints.  This specification uses discriminators to properly handle polymorphic request/response schemas. The 'action' field serves as the discriminator property to differentiate between different request and response types (AddClient, UpdateClient, AddOrder).   # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from whmcs_client.models.whmcs_base_request import WHMCSBaseRequest  # noqa: F401,E501

class AddClientRequest(WHMCSBaseRequest):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'action': 'str',
        'owner_user_id': 'int',
        'firstname': 'str',
        'lastname': 'str',
        'companyname': 'str',
        'email': 'str',
        'address1': 'str',
        'address2': 'str',
        'city': 'str',
        'state': 'str',
        'postcode': 'str',
        'country': 'str',
        'phonenumber': 'str',
        'tax_id': 'str',
        'password2': 'str',
        'securityqid': 'int',
        'securityqans': 'str',
        'currency': 'int',
        'groupid': 'int',
        'customfields': 'str',
        'language': 'str',
        'clientip': 'str',
        'notes': 'str',
        'marketingoptin': 'bool',
        'noemail': 'bool',
        'skipvalidation': 'bool'
    }
    if hasattr(WHMCSBaseRequest, "swagger_types"):
        swagger_types.update(WHMCSBaseRequest.swagger_types)

    attribute_map = {
        'action': 'action',
        'owner_user_id': 'owner_user_id',
        'firstname': 'firstname',
        'lastname': 'lastname',
        'companyname': 'companyname',
        'email': 'email',
        'address1': 'address1',
        'address2': 'address2',
        'city': 'city',
        'state': 'state',
        'postcode': 'postcode',
        'country': 'country',
        'phonenumber': 'phonenumber',
        'tax_id': 'tax_id',
        'password2': 'password2',
        'securityqid': 'securityqid',
        'securityqans': 'securityqans',
        'currency': 'currency',
        'groupid': 'groupid',
        'customfields': 'customfields',
        'language': 'language',
        'clientip': 'clientip',
        'notes': 'notes',
        'marketingoptin': 'marketingoptin',
        'noemail': 'noemail',
        'skipvalidation': 'skipvalidation'
    }
    if hasattr(WHMCSBaseRequest, "attribute_map"):
        attribute_map.update(WHMCSBaseRequest.attribute_map)

    def __init__(self, action=None, owner_user_id=None, firstname=None, lastname=None, companyname=None, email=None, address1=None, address2=None, city=None, state=None, postcode=None, country=None, phonenumber=None, tax_id=None, password2=None, securityqid=None, securityqans=None, currency=None, groupid=None, customfields=None, language=None, clientip=None, notes=None, marketingoptin=None, noemail=None, skipvalidation=None, *args, **kwargs):  # noqa: E501
        """AddClientRequest - a model defined in Swagger"""  # noqa: E501
        self._action = None
        self._owner_user_id = None
        self._firstname = None
        self._lastname = None
        self._companyname = None
        self._email = None
        self._address1 = None
        self._address2 = None
        self._city = None
        self._state = None
        self._postcode = None
        self._country = None
        self._phonenumber = None
        self._tax_id = None
        self._password2 = None
        self._securityqid = None
        self._securityqans = None
        self._currency = None
        self._groupid = None
        self._customfields = None
        self._language = None
        self._clientip = None
        self._notes = None
        self._marketingoptin = None
        self._noemail = None
        self._skipvalidation = None
        self.discriminator = None
        self.action = action
        if owner_user_id is not None:
            self.owner_user_id = owner_user_id
        self.firstname = firstname
        self.lastname = lastname
        if companyname is not None:
            self.companyname = companyname
        self.email = email
        self.address1 = address1
        if address2 is not None:
            self.address2 = address2
        self.city = city
        self.state = state
        self.postcode = postcode
        self.country = country
        self.phonenumber = phonenumber
        if tax_id is not None:
            self.tax_id = tax_id
        if password2 is not None:
            self.password2 = password2
        if securityqid is not None:
            self.securityqid = securityqid
        if securityqans is not None:
            self.securityqans = securityqans
        if currency is not None:
            self.currency = currency
        if groupid is not None:
            self.groupid = groupid
        if customfields is not None:
            self.customfields = customfields
        if language is not None:
            self.language = language
        if clientip is not None:
            self.clientip = clientip
        if notes is not None:
            self.notes = notes
        if marketingoptin is not None:
            self.marketingoptin = marketingoptin
        if noemail is not None:
            self.noemail = noemail
        if skipvalidation is not None:
            self.skipvalidation = skipvalidation
        WHMCSBaseRequest.__init__(self, *args, **kwargs)

    @property
    def action(self):
        """Gets the action of this AddClientRequest.  # noqa: E501

        Must be 'AddClient'  # noqa: E501

        :return: The action of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this AddClientRequest.

        Must be 'AddClient'  # noqa: E501

        :param action: The action of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if action is None:
            raise ValueError("Invalid value for `action`, must not be `None`")  # noqa: E501
        allowed_values = ["AddClient"]  # noqa: E501
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def owner_user_id(self):
        """Gets the owner_user_id of this AddClientRequest.  # noqa: E501

        The ID of the user that should own the client  # noqa: E501

        :return: The owner_user_id of this AddClientRequest.  # noqa: E501
        :rtype: int
        """
        return self._owner_user_id

    @owner_user_id.setter
    def owner_user_id(self, owner_user_id):
        """Sets the owner_user_id of this AddClientRequest.

        The ID of the user that should own the client  # noqa: E501

        :param owner_user_id: The owner_user_id of this AddClientRequest.  # noqa: E501
        :type: int
        """

        self._owner_user_id = owner_user_id

    @property
    def firstname(self):
        """Gets the firstname of this AddClientRequest.  # noqa: E501

        First name of the client  # noqa: E501

        :return: The firstname of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._firstname

    @firstname.setter
    def firstname(self, firstname):
        """Sets the firstname of this AddClientRequest.

        First name of the client  # noqa: E501

        :param firstname: The firstname of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if firstname is None:
            raise ValueError("Invalid value for `firstname`, must not be `None`")  # noqa: E501

        self._firstname = firstname

    @property
    def lastname(self):
        """Gets the lastname of this AddClientRequest.  # noqa: E501

        Last name of the client  # noqa: E501

        :return: The lastname of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._lastname

    @lastname.setter
    def lastname(self, lastname):
        """Sets the lastname of this AddClientRequest.

        Last name of the client  # noqa: E501

        :param lastname: The lastname of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if lastname is None:
            raise ValueError("Invalid value for `lastname`, must not be `None`")  # noqa: E501

        self._lastname = lastname

    @property
    def companyname(self):
        """Gets the companyname of this AddClientRequest.  # noqa: E501

        Company name  # noqa: E501

        :return: The companyname of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._companyname

    @companyname.setter
    def companyname(self, companyname):
        """Sets the companyname of this AddClientRequest.

        Company name  # noqa: E501

        :param companyname: The companyname of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._companyname = companyname

    @property
    def email(self):
        """Gets the email of this AddClientRequest.  # noqa: E501

        Email address of the client  # noqa: E501

        :return: The email of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this AddClientRequest.

        Email address of the client  # noqa: E501

        :param email: The email of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501

        self._email = email

    @property
    def address1(self):
        """Gets the address1 of this AddClientRequest.  # noqa: E501

        Address line 1  # noqa: E501

        :return: The address1 of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._address1

    @address1.setter
    def address1(self, address1):
        """Sets the address1 of this AddClientRequest.

        Address line 1  # noqa: E501

        :param address1: The address1 of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if address1 is None:
            raise ValueError("Invalid value for `address1`, must not be `None`")  # noqa: E501

        self._address1 = address1

    @property
    def address2(self):
        """Gets the address2 of this AddClientRequest.  # noqa: E501

        Address line 2  # noqa: E501

        :return: The address2 of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._address2

    @address2.setter
    def address2(self, address2):
        """Sets the address2 of this AddClientRequest.

        Address line 2  # noqa: E501

        :param address2: The address2 of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._address2 = address2

    @property
    def city(self):
        """Gets the city of this AddClientRequest.  # noqa: E501

        City  # noqa: E501

        :return: The city of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """Sets the city of this AddClientRequest.

        City  # noqa: E501

        :param city: The city of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if city is None:
            raise ValueError("Invalid value for `city`, must not be `None`")  # noqa: E501

        self._city = city

    @property
    def state(self):
        """Gets the state of this AddClientRequest.  # noqa: E501

        State  # noqa: E501

        :return: The state of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this AddClientRequest.

        State  # noqa: E501

        :param state: The state of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if state is None:
            raise ValueError("Invalid value for `state`, must not be `None`")  # noqa: E501

        self._state = state

    @property
    def postcode(self):
        """Gets the postcode of this AddClientRequest.  # noqa: E501

        Postal code  # noqa: E501

        :return: The postcode of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._postcode

    @postcode.setter
    def postcode(self, postcode):
        """Sets the postcode of this AddClientRequest.

        Postal code  # noqa: E501

        :param postcode: The postcode of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if postcode is None:
            raise ValueError("Invalid value for `postcode`, must not be `None`")  # noqa: E501

        self._postcode = postcode

    @property
    def country(self):
        """Gets the country of this AddClientRequest.  # noqa: E501

        2 character ISO country code  # noqa: E501

        :return: The country of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this AddClientRequest.

        2 character ISO country code  # noqa: E501

        :param country: The country of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if country is None:
            raise ValueError("Invalid value for `country`, must not be `None`")  # noqa: E501

        self._country = country

    @property
    def phonenumber(self):
        """Gets the phonenumber of this AddClientRequest.  # noqa: E501

        Phone number  # noqa: E501

        :return: The phonenumber of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._phonenumber

    @phonenumber.setter
    def phonenumber(self, phonenumber):
        """Sets the phonenumber of this AddClientRequest.

        Phone number  # noqa: E501

        :param phonenumber: The phonenumber of this AddClientRequest.  # noqa: E501
        :type: str
        """
        if phonenumber is None:
            raise ValueError("Invalid value for `phonenumber`, must not be `None`")  # noqa: E501

        self._phonenumber = phonenumber

    @property
    def tax_id(self):
        """Gets the tax_id of this AddClientRequest.  # noqa: E501

        Client's tax ID  # noqa: E501

        :return: The tax_id of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._tax_id

    @tax_id.setter
    def tax_id(self, tax_id):
        """Sets the tax_id of this AddClientRequest.

        Client's tax ID  # noqa: E501

        :param tax_id: The tax_id of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._tax_id = tax_id

    @property
    def password2(self):
        """Gets the password2 of this AddClientRequest.  # noqa: E501

        Password for the new user account  # noqa: E501

        :return: The password2 of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._password2

    @password2.setter
    def password2(self, password2):
        """Sets the password2 of this AddClientRequest.

        Password for the new user account  # noqa: E501

        :param password2: The password2 of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._password2 = password2

    @property
    def securityqid(self):
        """Gets the securityqid of this AddClientRequest.  # noqa: E501

        Security question ID  # noqa: E501

        :return: The securityqid of this AddClientRequest.  # noqa: E501
        :rtype: int
        """
        return self._securityqid

    @securityqid.setter
    def securityqid(self, securityqid):
        """Sets the securityqid of this AddClientRequest.

        Security question ID  # noqa: E501

        :param securityqid: The securityqid of this AddClientRequest.  # noqa: E501
        :type: int
        """

        self._securityqid = securityqid

    @property
    def securityqans(self):
        """Gets the securityqans of this AddClientRequest.  # noqa: E501

        Security question answer  # noqa: E501

        :return: The securityqans of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._securityqans

    @securityqans.setter
    def securityqans(self, securityqans):
        """Sets the securityqans of this AddClientRequest.

        Security question answer  # noqa: E501

        :param securityqans: The securityqans of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._securityqans = securityqans

    @property
    def currency(self):
        """Gets the currency of this AddClientRequest.  # noqa: E501

        Currency ID  # noqa: E501

        :return: The currency of this AddClientRequest.  # noqa: E501
        :rtype: int
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this AddClientRequest.

        Currency ID  # noqa: E501

        :param currency: The currency of this AddClientRequest.  # noqa: E501
        :type: int
        """

        self._currency = currency

    @property
    def groupid(self):
        """Gets the groupid of this AddClientRequest.  # noqa: E501

        Client group ID  # noqa: E501

        :return: The groupid of this AddClientRequest.  # noqa: E501
        :rtype: int
        """
        return self._groupid

    @groupid.setter
    def groupid(self, groupid):
        """Sets the groupid of this AddClientRequest.

        Client group ID  # noqa: E501

        :param groupid: The groupid of this AddClientRequest.  # noqa: E501
        :type: int
        """

        self._groupid = groupid

    @property
    def customfields(self):
        """Gets the customfields of this AddClientRequest.  # noqa: E501

        Base64 encoded serialized array of custom field values  # noqa: E501

        :return: The customfields of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._customfields

    @customfields.setter
    def customfields(self, customfields):
        """Sets the customfields of this AddClientRequest.

        Base64 encoded serialized array of custom field values  # noqa: E501

        :param customfields: The customfields of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._customfields = customfields

    @property
    def language(self):
        """Gets the language of this AddClientRequest.  # noqa: E501

        Default language setting  # noqa: E501

        :return: The language of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._language

    @language.setter
    def language(self, language):
        """Sets the language of this AddClientRequest.

        Default language setting  # noqa: E501

        :param language: The language of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._language = language

    @property
    def clientip(self):
        """Gets the clientip of this AddClientRequest.  # noqa: E501

        Originating IP address  # noqa: E501

        :return: The clientip of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._clientip

    @clientip.setter
    def clientip(self, clientip):
        """Sets the clientip of this AddClientRequest.

        Originating IP address  # noqa: E501

        :param clientip: The clientip of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._clientip = clientip

    @property
    def notes(self):
        """Gets the notes of this AddClientRequest.  # noqa: E501

        Admin only notes  # noqa: E501

        :return: The notes of this AddClientRequest.  # noqa: E501
        :rtype: str
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """Sets the notes of this AddClientRequest.

        Admin only notes  # noqa: E501

        :param notes: The notes of this AddClientRequest.  # noqa: E501
        :type: str
        """

        self._notes = notes

    @property
    def marketingoptin(self):
        """Gets the marketingoptin of this AddClientRequest.  # noqa: E501

        Opt-in to marketing emails  # noqa: E501

        :return: The marketingoptin of this AddClientRequest.  # noqa: E501
        :rtype: bool
        """
        return self._marketingoptin

    @marketingoptin.setter
    def marketingoptin(self, marketingoptin):
        """Sets the marketingoptin of this AddClientRequest.

        Opt-in to marketing emails  # noqa: E501

        :param marketingoptin: The marketingoptin of this AddClientRequest.  # noqa: E501
        :type: bool
        """

        self._marketingoptin = marketingoptin

    @property
    def noemail(self):
        """Gets the noemail of this AddClientRequest.  # noqa: E501

        Do not send welcome email  # noqa: E501

        :return: The noemail of this AddClientRequest.  # noqa: E501
        :rtype: bool
        """
        return self._noemail

    @noemail.setter
    def noemail(self, noemail):
        """Sets the noemail of this AddClientRequest.

        Do not send welcome email  # noqa: E501

        :param noemail: The noemail of this AddClientRequest.  # noqa: E501
        :type: bool
        """

        self._noemail = noemail

    @property
    def skipvalidation(self):
        """Gets the skipvalidation of this AddClientRequest.  # noqa: E501

        Do not enforce required fields  # noqa: E501

        :return: The skipvalidation of this AddClientRequest.  # noqa: E501
        :rtype: bool
        """
        return self._skipvalidation

    @skipvalidation.setter
    def skipvalidation(self, skipvalidation):
        """Sets the skipvalidation of this AddClientRequest.

        Do not enforce required fields  # noqa: E501

        :param skipvalidation: The skipvalidation of this AddClientRequest.  # noqa: E501
        :type: bool
        """

        self._skipvalidation = skipvalidation

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddClientRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddClientRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
