# coding: utf-8

"""
    WHMCS API

    OpenAPI specification for the WHMCS API endpoints.  This specification uses discriminators to properly handle polymorphic request/response schemas. The 'action' field serves as the discriminator property to differentiate between different request and response types (AddClient, UpdateClient, AddOrder).   # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from whmcs_client.models.whmcs_base_response import WHMCSBaseResponse  # noqa: F401,E501

class AddOrderResponse(WHMCSBaseResponse):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'action': 'str',
        'orderid': 'str',
        'serviceids': 'str',
        'addonids': 'str',
        'domainids': 'str',
        'invoiceid': 'int'
    }
    if hasattr(WHMCSBaseResponse, "swagger_types"):
        swagger_types.update(WHMCSBaseResponse.swagger_types)

    attribute_map = {
        'action': 'action',
        'orderid': 'orderid',
        'serviceids': 'serviceids',
        'addonids': 'addonids',
        'domainids': 'domainids',
        'invoiceid': 'invoiceid'
    }
    if hasattr(WHMCSBaseResponse, "attribute_map"):
        attribute_map.update(WHMCSBaseResponse.attribute_map)

    def __init__(self, action=None, orderid=None, serviceids=None, addonids=None, domainids=None, invoiceid=None, *args, **kwargs):  # noqa: E501
        """AddOrderResponse - a model defined in Swagger"""  # noqa: E501
        self._action = None
        self._orderid = None
        self._serviceids = None
        self._addonids = None
        self._domainids = None
        self._invoiceid = None
        self.discriminator = None
        if action is not None:
            self.action = action
        if orderid is not None:
            self.orderid = orderid
        if serviceids is not None:
            self.serviceids = serviceids
        if addonids is not None:
            self.addonids = addonids
        if domainids is not None:
            self.domainids = domainids
        if invoiceid is not None:
            self.invoiceid = invoiceid
        WHMCSBaseResponse.__init__(self, *args, **kwargs)

    @property
    def action(self):
        """Gets the action of this AddOrderResponse.  # noqa: E501

        Always 'AddOrder' for AddOrder responses  # noqa: E501

        :return: The action of this AddOrderResponse.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this AddOrderResponse.

        Always 'AddOrder' for AddOrder responses  # noqa: E501

        :param action: The action of this AddOrderResponse.  # noqa: E501
        :type: str
        """
        allowed_values = ["AddOrder"]  # noqa: E501
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def orderid(self):
        """Gets the orderid of this AddOrderResponse.  # noqa: E501

        The Order ID for the created order  # noqa: E501

        :return: The orderid of this AddOrderResponse.  # noqa: E501
        :rtype: str
        """
        return self._orderid

    @orderid.setter
    def orderid(self, orderid):
        """Sets the orderid of this AddOrderResponse.

        The Order ID for the created order  # noqa: E501

        :param orderid: The orderid of this AddOrderResponse.  # noqa: E501
        :type: str
        """

        self._orderid = orderid

    @property
    def serviceids(self):
        """Gets the serviceids of this AddOrderResponse.  # noqa: E501

        The Service ID(s) created by the order  # noqa: E501

        :return: The serviceids of this AddOrderResponse.  # noqa: E501
        :rtype: str
        """
        return self._serviceids

    @serviceids.setter
    def serviceids(self, serviceids):
        """Sets the serviceids of this AddOrderResponse.

        The Service ID(s) created by the order  # noqa: E501

        :param serviceids: The serviceids of this AddOrderResponse.  # noqa: E501
        :type: str
        """

        self._serviceids = serviceids

    @property
    def addonids(self):
        """Gets the addonids of this AddOrderResponse.  # noqa: E501

        The Addon ID(s) created by the order  # noqa: E501

        :return: The addonids of this AddOrderResponse.  # noqa: E501
        :rtype: str
        """
        return self._addonids

    @addonids.setter
    def addonids(self, addonids):
        """Sets the addonids of this AddOrderResponse.

        The Addon ID(s) created by the order  # noqa: E501

        :param addonids: The addonids of this AddOrderResponse.  # noqa: E501
        :type: str
        """

        self._addonids = addonids

    @property
    def domainids(self):
        """Gets the domainids of this AddOrderResponse.  # noqa: E501

        The Domain ID(s) created by the order  # noqa: E501

        :return: The domainids of this AddOrderResponse.  # noqa: E501
        :rtype: str
        """
        return self._domainids

    @domainids.setter
    def domainids(self, domainids):
        """Sets the domainids of this AddOrderResponse.

        The Domain ID(s) created by the order  # noqa: E501

        :param domainids: The domainids of this AddOrderResponse.  # noqa: E501
        :type: str
        """

        self._domainids = domainids

    @property
    def invoiceid(self):
        """Gets the invoiceid of this AddOrderResponse.  # noqa: E501

        The Invoice ID created for the order  # noqa: E501

        :return: The invoiceid of this AddOrderResponse.  # noqa: E501
        :rtype: int
        """
        return self._invoiceid

    @invoiceid.setter
    def invoiceid(self, invoiceid):
        """Sets the invoiceid of this AddOrderResponse.

        The Invoice ID created for the order  # noqa: E501

        :param invoiceid: The invoiceid of this AddOrderResponse.  # noqa: E501
        :type: int
        """

        self._invoiceid = invoiceid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddOrderResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddOrderResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
